﻿'_____________________________________________________________-


'                       Introduction to Stream Reader in ASP.Net


'                                           Ron Kessler

'                                         Created 2/22/08
'_____________________________________________________________

'Updated 2/25/08

'Updates:
'   Updated to VS2008. 

'NOTES:

'If you want to listbox to work like you expect, then set the autopostback property=true
'features include,
'   How to make a message box on a web form
'   How to iterate through the controls collection
'   How to use stream reader
'   Introduction to the IsPostBack property
'   How to set the root path for the application
'   Reminder about formatting currency



'==================START OF CODE======================
Option Explicit On
Imports System.IO        'this adds streamreader class


Partial Class _Default
    Inherits System.Web.UI.Page


    Const TAXRATE As Decimal = 0.075

    Dim rootPath As String = System.Web.Hosting.HostingEnvironment.MapPath("~")
    Dim FileName As String = rootPath & ("\items.txt")


    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Not IsPostBack Then
            Me.btnReturn.Attributes.Add("onclick", "return confirm('Are you finished shopping?');")
        End If

        txtItem.Style.Add("text-align", "right")
        txtPrice.Style.Add("text-align", "right")
        txtQuantity.Style.Add("text-align", "right")
        txtSubtotal.Style.Add("text-align", "right")
        txtTax.Style.Add("text-align", "right")
        txtTotal.Style.Add("text-align", "right")

        GetItems()
    End Sub


    Private Sub GetItems()


        '---we only want to read our data once so make sure it is inside the IsPostBack stuff
        If Not IsPostBack Then
            Dim MyReader As New StreamReader(FileName)
            Dim ItemInFile As String
            Dim Price As String
            Dim Product As String

            Try

                Do While MyReader.Peek <> -1

                    ItemInFile = MyReader.ReadLine()       'actual text in the file
                    Product = Left(ItemInFile, 10).Trim    'the first 10 characters are the item
                    Price = Mid(ItemInFile, 20).Trim         'starting at 20 we have the prices

                    '---add the product & price Product is text and price is the value. See items collection in the
                    'properties window for the listbox

                    lstItems.Items.Add(New ListItem(Product, Price))

                Loop


            Catch
                lblError.Text = "I can't read the data file."
                lblError.Visible = True

            Finally
                MyReader.Close()
            End Try

        End If

    End Sub

    Protected Sub lstItems_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles lstItems.SelectedIndexChanged
        '---once the text property contains the item and the value property contains the price, grab them!
        txtItem.Text = lstItems.SelectedItem.Text
        txtPrice.Text = lstItems.SelectedValue

    End Sub

    Protected Sub btnCheckOut_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnCheckOut.Click
        Try
            lblError.Visible = False
            '---compute sub total
            txtSubtotal.Text = FormatNumber(txtPrice.Text * txtQuantity.Text)

            '---compute tax
            txtTax.Text = FormatNumber(txtSubtotal.Text * TAXRATE)

            '---amount due
            txtTotal.Text = FormatNumber(Convert.ToDecimal(txtSubtotal.Text) + Convert.ToDecimal(txtTax.Text))


        Catch
            lblError.Text = "Please make sure all data is entered correctly...."
            lblError.Visible = True

        End Try
    End Sub

    Protected Sub btnClear_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnClear.Click
        '  ---use this code for a content page webform

        'For Each ctrl In Me.Master.FindControl("ContentPlaceHolder1").Controls
        '    If ctrl.GetType() Is GetType(TextBox) Then
        '        CType(ctrl, TextBox).Text = ""
        '    End If
        'Next

        '---use this for a regular web form
        Dim ctrl As Control
        For Each ctrl In Page.FindControl("Form1").Controls
            If ctrl.GetType() Is GetType(TextBox) Then
                CType(ctrl, TextBox).Text = ""
            End If
        Next

    End Sub

    Protected Sub btnReturn_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnReturn.Click
        Response.Redirect("default.aspx")
    End Sub
End Class
